"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ResizeHorizon = exports.ResizeVertical = exports.Resize = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _hammerjs = require("hammerjs");

var _hammerjs2 = _interopRequireDefault(_hammerjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createId() {
    var id = -1;
    return function () {
        id = id + 1;
        return id;
    };
}
var getResizeId = createId();

var Resize = exports.Resize = function (_Component) {
    _inherits(Resize, _Component);

    function Resize(props) {
        _classCallCheck(this, Resize);

        var _this = _possibleConstructorReturn(this, (Resize.__proto__ || Object.getPrototypeOf(Resize)).call(this, props));

        _this.state = {
            resizeType: "",
            resizeId: getResizeId(),
            handleWidth: "5px",
            handleColor: "#999",
            onResizeStart: function onResizeStart() {},
            onResizeStop: function onResizeStop() {},
            onResizeMove: function onResizeMove() {},
            onResizeWindow: function onResizeWindow() {}
        };

        _this.updateState = _this.updateState.bind(_this);
        _this.getResize = _this.getResize.bind(_this);
        _this.getResizeInf = _this.getResizeInf.bind(_this);
        _this.initialResize = _this.initialResize.bind(_this);
        _this.initialVertical = _this.initialVertical.bind(_this);
        _this.initialHorizon = _this.initialHorizon.bind(_this);
        _this.eventHandle = _this.eventHandle.bind(_this);

        _this.resizeVertical = _this.resizeVertical.bind(_this);
        _this.resizeHorizon = _this.resizeHorizon.bind(_this);
        _this.windowResizeVertical = _this.windowResizeVertical.bind(_this);
        _this.windowResizeHorizon = _this.windowResizeHorizon.bind(_this);
        return _this;
    }

    _createClass(Resize, [{
        key: "updateState",
        value: function updateState(props) {
            var handleWidth = props.handleWidth ? props.handleWidth : this.state.handleWidth;
            var handleColor = props.handleColor ? props.handleColor : this.state.handleColor;
            var onResizeStart = props.onResizeStart ? props.onResizeStart : this.state.onResizeStart;
            var onResizeStop = props.onResizeStop ? props.onResizeStop : this.state.onResizeStop;
            var onResizeMove = props.onResizeMove ? props.onResizeMove : this.state.onResizeMove;
            var onResizeWindow = props.onResizeWindow ? props.onResizeWindow : this.state.onResizeWindow;

            var resizeType = this.state.resizeType;
            if (props.children.length > 0) {
                if (props.children[0].type.name === "ResizeHorizon") {
                    resizeType = "horizon";
                } else if (props.children[0].type.name === "ResizeVertical") {
                    resizeType = "vertical";
                }
            }

            this.setState({
                resizeType: resizeType,
                handleWidth: handleWidth,
                handleColor: handleColor,
                onResizeStart: onResizeStart,
                onResizeStop: onResizeStop,
                onResizeMove: onResizeMove,
                onResizeWindow: onResizeWindow
            });
        }
    }, {
        key: "getResize",
        value: function getResize() {
            var $resize = document.querySelectorAll(".resize");
            var id = this.state.resizeId;
            var index = -1;
            for (var i = 0; i < $resize.length; i++) {
                if (id == $resize[i].getAttribute("data-resize-id")) {
                    index = i;
                }
            }
            return $resize[index];
        }
    }, {
        key: "getResizeElement",
        value: function getResizeElement(className) {
            var $resize = this.getResize();
            if (className === "resize") {
                return $resize;
            }

            var $child = $resize.childNodes;
            var list = [];
            for (var i = 0; i < $child.length; i++) {
                if ($child[i].classList.contains(className)) {
                    if ($child[i].getAttribute("data-show") != "none") {
                        list.push($child[i]);
                    }
                }
            }
            return list;
        }
    }, {
        key: "getResizeInf",
        value: function getResizeInf() {
            var type = this.state.resizeType;
            var childs = [];
            if (type === "vertical") {
                var $vertical = this.getResizeElement("resize-vertical");
                for (var i = 0; i < $vertical.length; i++) {
                    childs.push({ height: $vertical[i].offsetHeight });
                }
            } else if (type === "horizon") {
                var $horizon = this.getResizeElement("resize-horizon");
                for (var i = 0; i < $horizon.length; i++) {
                    childs.push({ width: $horizon[i].offsetWidth });
                }
            }

            return {
                type: type,
                resizeId: this.state.resizeId,
                resizeChilds: childs
            };
        }
    }, {
        key: "stopUserSelect",
        value: function stopUserSelect() {
            document.body.style.userSelect = "none";
            document.body.style.WebkitUserSelect = "none";
            document.body.style.MozUserSelect = "none";
            document.body.style.MsUserSelect = "none";
        }
    }, {
        key: "deselect",
        value: function deselect() {
            if (window.getSelection) {
                var selection = window.getSelection();
                selection.collapse(document.body, 0);
            }
        }
    }, {
        key: "onUserSelect",
        value: function onUserSelect() {
            document.body.style.userSelect = "";
            document.body.style.WebkitUserSelect = "";
            document.body.style.MozUserSelect = "";
            document.body.style.MsUserSelect = "";
        }
    }, {
        key: "eventHandle",
        value: function eventHandle() {
            var _this2 = this;

            var type = this.state.resizeType;
            var $handle = [];
            if (type === "vertical") {
                $handle = this.getResizeElement("resize-handle-vertical");
            } else if (type === "horizon") {
                $handle = this.getResizeElement("resize-handle-horizon");
            }

            for (var i = 0; i < $handle.length; i++) {
                var hammertime = new _hammerjs2.default($handle[i]);
                hammertime.get("pan").set({ threshold: 1 });

                hammertime.on("panstart", function (ev) {
                    _this2.stopUserSelect();
                    _this2.deselect();
                    _this2.state.onResizeStart(_this2.getResizeInf());
                });
                hammertime.on("panend", function (ev) {
                    _this2.onUserSelect();
                    _this2.deselect();
                    _this2.state.onResizeStop(_this2.getResizeInf());
                });
                hammertime.on("panmove", function (ev) {
                    _this2.deselect();
                    if (type === "vertical") {
                        _this2.resizeVertical(ev);
                        _this2.state.onResizeMove(_this2.getResizeInf());
                    } else if (type === "horizon") {
                        _this2.resizeHorizon(ev);
                        _this2.state.onResizeMove(_this2.getResizeInf());
                    }
                });
            }
        }
    }, {
        key: "initialVertical",
        value: function initialVertical() {
            var $resize = this.getResizeElement("resize");
            var $vertical = this.getResizeElement("resize-vertical");
            if (!$resize || $vertical.length === 0) return;

            // remove handle
            var $handle = this.getResizeElement("resize-handle-vertical");
            for (var i = 0; i < $handle.length; i++) {
                $handle[i].parentNode.removeChild($handle[i]);
            }

            var handleHeight = parseInt(this.state.handleWidth);
            var handleColor = this.state.handleColor;
            var sumHeight = 0;

            for (var i = 0; i < $vertical.length; i++) {
                // vertical
                var minHeight = $vertical[i].getAttribute("data-min-height");
                $vertical[i].setAttribute("min-height", minHeight);

                // handle style
                var _$handle = document.createElement("div");
                _$handle.className = "resize-handle-vertical";
                _$handle.style.height = handleHeight + "px";
                _$handle.style.cursor = "s-resize";
                _$handle.style.backgroundColor = handleColor;

                if ($vertical[i + 1]) {
                    $vertical[i].parentNode.insertBefore(_$handle, $vertical[i].nextSibling);
                    sumHeight += handleHeight;
                }

                if ($vertical.length - 1 != i) {
                    sumHeight += $vertical[i].offsetHeight;
                }
            }
            $vertical[$vertical.length - 1].style.height = $resize.offsetHeight - sumHeight + "px";
        }
    }, {
        key: "resizeVertical",
        value: function resizeVertical(e) {
            if (e.velocityY === 0) return;
            var $resize = this.getResizeElement("resize");
            var $vertical = this.getResizeElement("resize-vertical");
            var $handle = this.getResizeElement("resize-handle-vertical");
            if (!$resize || $vertical.length === 0 || $handle.length === 0) return;

            var direction = e.velocityY > 0 ? "down" : "up";
            var indx_hand = $handle.indexOf(e.target);
            var $prev = $vertical[indx_hand];
            var $next = $vertical[indx_hand + 1];
            var prevMinHeight = parseInt($prev.getAttribute("min-height"));
            var nextMinHeight = parseInt($next.getAttribute("min-height"));

            if (direction === "up") {
                var indx_prev = $vertical.indexOf($prev);
                for (var i = $vertical.length - 1; 0 <= i; i--) {
                    if (indx_prev >= i) {
                        if ($prev.offsetHeight <= prevMinHeight) {
                            $prev = $vertical[i];
                            prevMinHeight = parseInt($prev.getAttribute("min-height"));
                        }
                    }
                }
            } else if (direction === "down") {
                var indx_next = $vertical.indexOf($next);
                for (var i = 0; i < $vertical.length; i++) {
                    if (indx_next <= i) {
                        if ($next.offsetHeight <= nextMinHeight) {
                            $next = $vertical[i];
                            nextMinHeight = parseInt($next.getAttribute("min-height"));
                        }
                    }
                }
            }

            var prevHeight = 0;
            var nextHeight = 0;
            var sumPrevHeight = 0;
            var sumHeight = 0;
            var flag = true;
            for (var i = 0; i < $vertical.length; i++) {
                if (flag) {
                    if ($handle[i] === e.target) {
                        flag = false;
                    }
                    if ($vertical[i] != $prev) {
                        sumPrevHeight += $vertical[i].offsetHeight;
                        sumPrevHeight += $handle[i].offsetHeight;
                    }
                }

                if ($vertical[i] !== $prev && $vertical[i] !== $next) {
                    sumHeight += $vertical[i].offsetHeight;
                }

                if ($handle[i]) {
                    sumHeight += $handle[i].offsetHeight;
                }
            }
            prevHeight = e.center.y - sumPrevHeight - $resize.getBoundingClientRect().top;
            nextHeight = $resize.offsetHeight - (sumHeight + prevHeight);

            if (prevHeight < prevMinHeight) prevHeight = prevMinHeight;
            if (nextHeight < nextMinHeight) nextHeight = nextMinHeight;

            if (direction === "down") {
                prevHeight = $resize.offsetHeight - sumHeight - nextHeight;
                if (prevHeight < prevMinHeight) prevHeight = prevMinHeight;
            } else if (direction === "up") {
                nextHeight = $resize.offsetHeight - sumHeight - prevHeight;
                if (nextHeight < nextMinHeight) nextHeight = nextMinHeight;
            }

            if ($resize.offsetHeight === sumHeight + prevHeight + nextHeight) {
                $prev.style.height = prevHeight + "px";
                $next.style.height = nextHeight + "px";
            }
        }
    }, {
        key: "windowResizeVertical",
        value: function windowResizeVertical() {
            var $resize = this.getResizeElement("resize");
            var $vertical = this.getResizeElement("resize-vertical");
            var $handle = this.getResizeElement("resize-handle-vertical");
            if (!$resize || $vertical.length === 0) return;

            if ($vertical.length === 1) {
                $vertical[0].style.height = $resize.offsetHeight + "px";
                return;
            }

            var sum = 0;
            var remain = 0;
            for (var i = 0; i < $vertical.length; i++) {
                sum += $vertical[i].offsetHeight;
            }
            for (var i = 0; i < $handle.length; i++) {
                sum += $handle[i].offsetHeight;
            }
            remain = $resize.offsetHeight - sum;

            if (remain > 0) {
                var last_idx = $vertical.length - 1;
                $vertical[last_idx].style.height = remain + $vertical[last_idx].offsetHeight + "px";
            } else if (remain < 0) {
                for (var i = $vertical.length - 1; 0 <= i; i--) {
                    var min_height = parseInt($vertical[i].getAttribute("min-height"));
                    remain += $vertical[i].offsetHeight - min_height;

                    if (remain >= 0) {
                        $vertical[i].style.height = remain + min_height + "px";
                        break;
                    }
                    $vertical[i].style.height = min_height + "px";
                }
            }

            this.state.onResizeWindow(this.getResizeInf());
        }
    }, {
        key: "initialHorizon",
        value: function initialHorizon() {
            var $resize = this.getResizeElement("resize");
            var $horizon = this.getResizeElement("resize-horizon");
            if (!$resize || $horizon.length === 0) return;

            // remove handle
            var $handle = this.getResizeElement("resize-handle-horizon");
            for (var i = 0; i < $handle.length; i++) {
                $handle[i].parentNode.removeChild($handle[i]);
            }

            var handleWidth = parseInt(this.state.handleWidth);
            var handleColor = this.state.handleColor;
            var sumWidth = 0;

            for (var i = 0; i < $horizon.length; i++) {
                // horizon
                var minWidth = $horizon[i].getAttribute("data-min-width");
                $horizon[i].setAttribute("min-width", minWidth);

                // handle style
                var _$handle2 = document.createElement("div");
                _$handle2.className = "resize-handle-horizon";
                _$handle2.style.width = handleWidth + "px";
                _$handle2.style.cursor = "w-resize";
                _$handle2.style.backgroundColor = handleColor;
                _$handle2.style.height = "100%";
                _$handle2.style.float = "left";

                if ($horizon[i + 1]) {
                    $horizon[i].parentNode.insertBefore(_$handle2, $horizon[i].nextSibling);
                    sumWidth += handleWidth;
                }
                if ($horizon.length - 1 != i) {
                    sumWidth += $horizon[i].offsetWidth;
                }
            }
            $horizon[$horizon.length - 1].style.width = $resize.offsetWidth - sumWidth + "px";
        }
    }, {
        key: "resizeHorizon",
        value: function resizeHorizon(e) {
            if (e.velocityX === 0) return;
            var $resize = this.getResizeElement("resize");
            var $horizon = this.getResizeElement("resize-horizon");
            var $handle = this.getResizeElement("resize-handle-horizon");
            if (!$resize || $horizon.length === 0 || $handle.length === 0) return;

            var direction = e.velocityX > 0 ? "right" : "left";
            var indx_hand = $handle.indexOf(e.target);
            var $prev = $horizon[indx_hand];
            var $next = $horizon[indx_hand + 1];
            var prevMinWidth = parseInt($prev.getAttribute("min-width"));
            var nextMinWidth = parseInt($next.getAttribute("min-width"));

            if (direction === "left") {
                var indx_prev = $horizon.indexOf($prev);
                for (var i = $horizon.length - 1; 0 <= i; i--) {
                    if (indx_prev >= i) {
                        if ($prev.offsetWidth <= prevMinWidth) {
                            $prev = $horizon[i];
                            prevMinWidth = parseInt($prev.getAttribute("min-width"));
                        }
                    }
                }
            } else if (direction === "right") {
                var indx_next = $horizon.indexOf($next);
                for (var i = 0; i < $horizon.length; i++) {
                    if (indx_next <= i) {
                        if ($next.offsetWidth <= nextMinWidth) {
                            $next = $horizon[i];
                            nextMinWidth = parseInt($next.getAttribute("min-width"));
                        }
                    }
                }
            }

            var prevWidth = 0;
            var nextWidth = 0;
            var sumPrevWidth = 0;
            var sumWidth = 0;
            var flag = true;
            for (var i = 0; i < $horizon.length; i++) {
                if (flag) {
                    if ($handle[i] === e.target) {
                        flag = false;
                    }
                    if ($horizon[i] != $prev) {
                        sumPrevWidth += $horizon[i].offsetWidth;
                        sumPrevWidth += $handle[i].offsetWidth;
                    }
                }

                if ($horizon[i] !== $prev && $horizon[i] !== $next) {
                    sumWidth += $horizon[i].offsetWidth;
                }

                if ($handle[i]) {
                    sumWidth += $handle[i].offsetWidth;
                }
            }
            prevWidth = e.center.x - sumPrevWidth - $resize.getBoundingClientRect().left;
            nextWidth = $resize.offsetWidth - (sumWidth + prevWidth);

            if (prevWidth < prevMinWidth) prevWidth = prevMinWidth;
            if (nextWidth < nextMinWidth) nextWidth = nextMinWidth;

            if (direction === "right") {
                prevWidth = $resize.offsetWidth - sumWidth - nextWidth;
                if (prevWidth < prevMinWidth) prevWidth = prevMinWidth;
            } else if (direction === "left") {
                nextWidth = $resize.offsetWidth - sumWidth - prevWidth;
                if (nextWidth < nextMinWidth) nextWidth = nextMinWidth;
            }

            if ($resize.offsetWidth === sumWidth + prevWidth + nextWidth) {
                $prev.style.width = prevWidth + "px";
                $next.style.width = nextWidth + "px";
            }
        }
    }, {
        key: "windowResizeHorizon",
        value: function windowResizeHorizon(e) {
            var $resize = this.getResizeElement("resize");
            var $horizon = this.getResizeElement("resize-horizon");
            var $handle = this.getResizeElement("resize-handle-horizon");
            if (!$resize || $horizon.length === 0 || $handle.length === 0) return;

            var sum = 0;
            var remain = 0;
            for (var i = 0; i < $horizon.length; i++) {
                sum += $horizon[i].offsetWidth;
            }
            for (var i = 0; i < $handle.length; i++) {
                sum += $handle[i].offsetWidth;
            }
            remain = $resize.offsetWidth - sum;

            if (remain > 0) {
                $horizon[$horizon.length - 1].style.width = remain + $horizon[$horizon.length - 1].offsetWidth + "px";
            } else if (remain < 0) {
                for (var i = $horizon.length - 1; 0 <= i; i--) {
                    var min_width = parseInt($horizon[i].getAttribute("min-width"));
                    remain += $horizon[i].offsetWidth - min_width - 1;
                    0;

                    if (remain >= 0) {
                        $horizon[i].style.width = remain + min_width + "px";
                        break;
                    }
                    $horizon[i].style.width = min_width + "px";
                }
            }

            this.state.onResizeWindow(this.getResizeInf());
        }
    }, {
        key: "initialResize",
        value: function initialResize() {
            var type = this.state.resizeType;
            if (type === "vertical") {
                this.initialVertical();
                this.eventHandle();
                this.windowResizeVertical();
            } else if (type === "horizon") {
                this.initialHorizon();
                this.eventHandle();
                this.windowResizeHorizon();
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            this.initialResize();
            var type = this.state.resizeType;
            if (type === "vertical") {
                window.addEventListener("resize", this.windowResizeVertical);
            } else if (type === "horizon") {
                window.addEventListener("resize", this.windowResizeHorizon);
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            var type = this.state.resizeType;
            if (type === "vertical") {
                window.removeEventListener("resize", this.windowResizeVertical);
            } else if (type === "horizon") {
                window.removeEventListener("resize", this.windowResizeHorizon);
            }
        }
    }, {
        key: "componentWillMount",
        value: function componentWillMount() {
            this.updateState(this.props);
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            this.updateState(nextProps);
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
            this.initialResize();
        }
    }, {
        key: "render",
        value: function render() {
            var id = this.state.resizeId;
            var type = this.state.resizeType;

            // resize style
            var style = {
                position: "absolute",
                top: "0",
                bottom: "0",
                left: "0",
                right: "0"
            };
            if (type === "horizon") {
                style.overflow = "hidden";
            }

            return _react2.default.createElement(
                "div",
                { className: "resize", "data-resize-id": id, style: style },
                this.props.children
            );
        }
    }]);

    return Resize;
}(_react.Component);

var ResizeVertical = exports.ResizeVertical = function (_Component2) {
    _inherits(ResizeVertical, _Component2);

    function ResizeVertical() {
        _classCallCheck(this, ResizeVertical);

        return _possibleConstructorReturn(this, (ResizeVertical.__proto__ || Object.getPrototypeOf(ResizeVertical)).apply(this, arguments));
    }

    _createClass(ResizeVertical, [{
        key: "render",
        value: function render() {
            var id = this.props.id ? this.props.id : "";
            var className = this.props.className ? this.props.className : "";
            var height = this.props.height ? this.props.height : "0";
            var minHeight = this.props.minHeight ? this.props.minHeight : "0";
            var overflow = this.props.overflow ? this.props.overflow : "hidden";
            var show = this.props.show == false || this.props.show == "false" || this.props.show == "off" || this.props.show == "none" ? "none" : "block";

            var style = {
                position: "relative",
                height: parseInt(height) + "px",
                overflow: overflow,
                display: show
            };

            return _react2.default.createElement(
                "div",
                {
                    id: id,
                    className: "resize-vertical " + className,
                    "data-height": height,
                    "data-min-height": parseInt(minHeight),
                    "data-show": show,
                    style: style
                },
                this.props.children
            );
        }
    }]);

    return ResizeVertical;
}(_react.Component);

var ResizeHorizon = exports.ResizeHorizon = function (_Component3) {
    _inherits(ResizeHorizon, _Component3);

    function ResizeHorizon() {
        _classCallCheck(this, ResizeHorizon);

        return _possibleConstructorReturn(this, (ResizeHorizon.__proto__ || Object.getPrototypeOf(ResizeHorizon)).apply(this, arguments));
    }

    _createClass(ResizeHorizon, [{
        key: "render",
        value: function render() {
            var id = this.props.id ? this.props.id : "";
            var className = this.props.className ? this.props.className : "";
            var width = this.props.width ? this.props.width : "0";
            var minWidth = this.props.minWidth ? this.props.minWidth : "0";
            var overflow = this.props.overflow ? this.props.overflow : "hidden";
            var show = this.props.show == false || this.props.show == "false" || this.props.show == "off" || this.props.show == "none" ? "none" : "block";

            var style = {
                position: "relative",
                height: "100%",
                width: parseInt(width) + "px",
                float: "left",
                overflow: overflow,
                display: show
            };

            return _react2.default.createElement(
                "div",
                {
                    id: id,
                    className: "resize-horizon " + className,
                    "data-min-width": parseInt(minWidth),
                    "data-show": show,
                    style: style
                },
                this.props.children
            );
        }
    }]);

    return ResizeHorizon;
}(_react.Component);